%define _use_internal_dependency_generator 0
%global momorel 2
%global pkglibdir	%{_libdir}/%{name}

Summary:	A CPU Emulator
Name:		qemu
Version:	0.6.1
Release:	%{momorel}m
License:	GPL
Group:		Development/Tools
URL:		http://fabrice.bellard.free.fr/qemu/
Source0:	http://fabrice.bellard.free.fr/qemu/%{name}-%{version}.tar.gz
NoSource: 0
#
Patch0:		qemu-cflags2.patch
Patch1:		qemu-non-sdl_static.patch
Patch2:		qemu-DESTDIR2.patch
Patch3:		qemu-noinstall-htmlfiles2.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-root
BuildRequires:	SDL-devel >= 1.2.7-9m time

%description
QEMU is a FAST! processor emulator. By using dynamic translation it
achieves a reasonnable speed while being easy to port on new host
CPUs.

QEMU has two operating modes:
* User mode emulation to launch Linux processes compiled for one CPU
  on another CPU
* Full system emulation to emulates a full system, including a processor
  and various peripherials.

It requires no host kernel patches to run.


%ifnarch arm
%package arm
Summary:	An emulator which allows to run ARM binaries
Group:		Development/Tools
Requires:	%{name} = %{version}-%{release}

%description arm
QEMU is a FAST! processor emulator which can be used to run ARM
binaries on %_target_cpu CPUs.
%endif


%ifnarch sparc
%package sparc
Summary:	An emulator which allows to run SPARC binaries
Group:		Development/Tools
Requires:	%{name} = %{version}-%{release}

%description sparc
QEMU is a FAST! processor emulator which can be used to run SPARC
binaries on %_target_cpu CPUs.
%endif


%ifnarch %ix86
%package x86
Summary:	An emulator which allows to run Intel i386 binaries
Group:		Development/Tools
Requires:	%{name} = %{version}-%{release}

%description x86
QEMU is a FAST! processor emulator which can be used to run Intel i386
binaries on %_target_cpu CPUs.
%endif


%ifnarch ppc
%package ppc
Summary:	An emulator which allows to run PPC binaries
Group:		Development/Tools
Requires:	%{name} = %{version}-%{release}

%description ppc
QEMU is a FAST! processor emulator which can be used to run PPC
binaries on %_target_cpu CPUs.
%endif

%prep

# < valgrind.spec
# XXX hack for GLIBC_PRIVATE...
%define reqprog         %{_builddir}/find-requires-%{name}
cat <<EOF >%{reqprog}
%{__find_requires} | grep -v 'libc.so.6(GLIBC_PRIVATE)'
EOF
chmod +x %{reqprog}
%define __find_requires         %{reqprog}

%setup -q
%patch0 -p1 -b .cflags
%patch1 -p1 -b .no-sdl_static
%patch2 -p1 -b .DESTDIR
%patch3 -p1 -b .noninstall-htmlfiles

%build

./configure \
        --prefix=%{_prefix} \
        --cc=%{__cc} \
        --make=%{__make} \
	--extra-cflags=%{optflags}
#	--interp-prefix=%{buildroot}%{_libdir}/qemu/%M \
%make

%install
rm -rf %{buildroot}
%{__make} install DESTDIR=%{buildroot}
%{__install} -d -m755 %{buildroot}%pkglibdir/{arm,sparc,ppc,i386}

#%%check #XXX
%ifarch %ix86
  %__make -C tests speed
%endif

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc COPYING* Changelog README* TODO *.html
%{_mandir}/man1/*
%{_bindir}/qemu
%{_bindir}/qemu-img
%{_datadir}/%{name}/ppc_rom.bin
%{_datadir}/%{name}/proll.bin
%{_datadir}/%{name}/vgabios-cirrus.bin
%dir %{pkglibdir}
%dir %{_datadir}/%{name}

%ifarch %{ix86}
%{_bindir}/qemu-i386
%{_bindir}/qemu-fast
%{_datadir}/%{name}/bios.bin
%{_datadir}/%{name}/vgabios.bin
%{_datadir}/%{name}/linux_boot.bin
%endif

%ifnarch %{ix86}
%{_bindir}/qemu-%{_arch}
%{_bindir}/qemu-system-%{_arch}
%endif

%ifnarch %{ix86}
%files x86
%defattr(-,root,root,-)
%{pkglibdir}/i386
%{_bindir}/*-i386
%{_datadir}/%{name}/bios.bin
%{_datadir}/%{name}/vgabios.bin
%{_datadir}/%{name}/linux_boot.bin
%endif

%ifnarch arm
%files arm
%defattr(-,root,root,-)
%{pkglibdir}/arm
%{_bindir}/*-arm
%endif

%ifnarch sparc
%files sparc
%defattr(-,root,root,-)
%{pkglibdir}/sparc
%{_bindir}/*-sparc
%endif

%ifnarch ppc
%files ppc
%defattr(-,root,root,-)
%{pkglibdir}/ppc
%{_bindir}/*-ppc
%endif

%changelog
* Sat Feb 12 2005 Masahiro Takahata <takahata@momonga-linux.org>
- (0.6.1-2m)
- rebuild against SDL-1.2.7-9m

* Wed Nov 17 2004 Kazuhiko <kazuhiko@fdiary.net>
- (0.6.1-1m)
- many bug fixes and new disk image formats
- remove qemu-cpu-exec.patch

* Wed Jul 14 2004 mutecat <mutecat@momonga-linux.org>
- (0.6.0-1m)
- update & add qemu-cpu-exec.patch
- qemu-cflags2.patch qemu-DESTDIR2.patch qemu-noinstall-htmlfiles2.patch
- patch shusei

* Sat Jun 12 2004 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.5.5-2m)
- add qemu-noinstall-htmlfiles.patch
  for fix below
      error: Installed (but unpackaged) file(s) found:
         /usr/share/doc/qemu/qemu-doc.html
         /usr/share/doc/qemu/qemu-tech.html

* Tue May 18 2004 Kazuhiko <kazuhiko@fdiary.net>
- (0.5.5-1m)
- much improved windows 98 support
- VGA support in PowerPC PREP target

* Sat May 01 2004 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.5.4-4m)
- add Patch2: qemu-DESTDIR.patch
- no use makeflags
- no use --interp-prefix

* Sat May  1 2004 Toru Hoshina <t@momonga-linux.org>
- (0.5.4-3m)
- linux_boot.bin
- force _use_internal_dependency_generator as 0.

* Thu Apr 29 2004 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.5.4-2m)
- add Patch1: qemu-non-sdl_static.patch
- add hack for GLIBC_PRIVATE from valgrind.spec

* Wed Apr 28 2004 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.5.4-1m)
- momonganized
- nosrc
- version up to 0.5.4
- comment out patch0
- update patch1, and rename patch0
- use %%{buildroot} nor $(DESTDIR) at makeflags 
- use %%{optflags} nor $RPM_OPT_FLAGS at configure
- tmp comment out %%check
- change License: GPL/LGPL to GPL

* Fri Jan  9 2004 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 0:0.5.1-0.fdr.1
- added -cflags patch to apply RPM_OPT_FLAGS
- added -ppc subpackage
- updated to 0.5.1

* Fri Nov 14 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 0:0.5.0-0.fdr.1
- updated to 0.5.0
- reworked large parts of the spec-file since upstream enables
  multi-target builds already

* Tue Sep  2 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> 0:0.4.3-0.fdr.1.3
- s!%%ifnarch x86!%%ifnarch %%ix86!

* Tue Sep  2 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> 0:0.4.3-0.fdr.1.2
- use '-Wl,-z -Wl,execstack' options to prevent crashes on exec-shield stack

* Thu Aug 21 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> 0:0.4.3-0.fdr.1.1
- added -nostrip patch

* Thu Aug 21 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> 0:0.4.3-0.fdr.1
- initial build
